/*============================================================================
  File:     2008FatalErrors.sql

  Summary:  This script shows some fatal (to CHECKDB) corruptions
			2008 only

  Date:     January 2010

  SQL Server Versions:
		10.0.2531.00 (SS2008 SP1)
------------------------------------------------------------------------------
  Written by Paul S. Randal, SQLskills.com

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  You may alter this code for your own *non-commercial* purposes. You may
  republish altered code as long as you give due credit.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

/* Setup
USE master;
GO

-- Get the backup from
-- http://www.sqlskills.com/pastConferences.asp
-- Make sure the restore path exists...
RESTORE DATABASE DemoFatalCorruption1 FROM
	DISK = 'D:\SQLskills\CorruptionDemoBackups\Corrupt2008DemoFatalCorruption1.bak'
WITH REPLACE, STATS = 10,
MOVE 'DemoFatalCorruption1' TO 'D:\SQLskills\DemoFatalCorruption1.mdf',
MOVE 'DemoFatalCorruption1_log' TO 'D:\SQLskills\DemoFatalCorruption1_log.ldf';
GO
RESTORE DATABASE DemoFatalCorruption2 FROM
	DISK = 'D:\SQLskills\CorruptionDemoBackups\Corrupt2008DemoFatalCorruption2.bak'
WITH REPLACE, STATS = 10,
MOVE 'DemoFatalCorruption2' TO 'D:\SQLskills\DemoFatalCorruption2.mdf',
MOVE 'DemoFatalCorruption2_log' TO 'D:\SQLskills\DemoFatalCorruption2_log.ldf';
GO
*/

USE master;
GO

-- Corrupt IAM chain for sys.syshobts
--
DBCC CHECKDB (DemoFatalCorruption1)
WITH NO_INFOMSGS, ALL_ERRORMSGS;
GO

-- Corruption found by the metadata layer
-- of the Engine
DBCC CHECKDB (DemoFatalCorruption2)
WITH NO_INFOMSGS, ALL_ERRORMSGS;
GO

DBCC CHECKCATALOG (DemoFatalCorruption2);
GO

